<template>
  <section class="content">
    <div class="container-fluid">
        <div class="row">

          <div class="col-12">

            <div class="card">
              <div class="card-header">
                <h3 class="card-title">Book List</h3>

                <div class="card-tools">

                  <button type="button" class="btn btn-sm btn-primary" @click="newModal">
                      <i class="fa fa-plus-square"></i>
                      Add New
                  </button>
                </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body table-responsive p-0">
                <table class="table table-hover">
                  <thead>
                    <tr>
                      <th>ID</th>
                      <th>Name</th>
                      <th>Description</th>
                      <th>Status</th>
                      <th>Action</th>
                    </tr>
                  </thead>
                  <tbody>
                     <tr v-for="book in books.data" :key="book.id">

                      <td>{{book.id}}</td>
                      <td>{{book.name}}</td>
                      <td>{{book.description }}</td>
                      <td>{{book.status.name}}</td>
                      <td>

                        <a href="#" @click="editModal(book)">
                            <i class="fa fa-edit blue"></i>
                        </a>
                        /
                        <a href="#" @click="deleteBook(book.id)">
                            <i class="fa fa-trash red"></i>
                        </a>
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>

              <!-- /.card-body -->
              <div class="card-footer">
                  <paginate
                      :page-range="5"
                      :page-count="books.last_page"
                      :click-handler="clickCallback"
                      :prev-text="'Prev'"
                      :next-text="'Next'"
                      :container-class="'pagination'"
                      :page-class="'page-item'"
                  >
                  </paginate>
                  <pagination :data="books" @pagination-change-page="getResults"></pagination>
              </div>
            </div>
            <!-- /.card -->
          </div>
        </div>

        <!-- Modal -->
        <div class="modal fade" id="addNew" tabindex="-1" role="dialog" aria-labelledby="addNew" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" v-show="!editmode">Create New Book</h5>
                    <h5 class="modal-title" v-show="editmode">Edit Book</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>

                <form @submit.prevent="editmode ? updateBook() : createBook()">
                    <div class="modal-body">
                        <div class="form-group">
                            <label>Name</label>
                            <input v-model="form.name" type="text" name="name"
                                class="form-control" :class="{ 'is-invalid': form.errors.has('name') }">
                            <has-error :form="form" field="name"></has-error>
                        </div>
                        <div class="form-group">
                            <label>Description</label>
                            <input v-model="form.description" type="text" name="description"
                                class="form-control" :class="{ 'is-invalid': form.errors.has('description') }">
                            <has-error :form="form" field="description"></has-error>
                        </div>
                        <div class="form-group">

                            <label>Status</label>
                            <select class="form-control" v-model="form.status_id">
                              <option
                                  v-for="(cat,index) in status" :key="index"
                                  :value="index"
                                  :selected="index == form.status_id">{{ cat }}</option>
                            </select>
                            <has-error :form="form" field="status_id"></has-error>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button v-show="editmode" type="submit" class="btn btn-success">Update</button>
                        <button v-show="!editmode" type="submit" class="btn btn-primary">Create</button>
                    </div>
                  </form>
                </div>
            </div>
        </div>
    </div>
  </section>
</template>

<script>
    import VueTagsInput from '@johmun/vue-tags-input';
    import Paginate from 'vuejs-paginate-next';

    export default {
      components: {
          VueTagsInput,
          paginate: Paginate,
        },
        data () {
            return {
                editmode: false,
                books : {},
                form: new Form({
                    id : '',
                    status : '',
                    name: '',
                    description: '',
                    status_id: '',
                }),
                status: [],

                tag:  '',
                autocompleteItems: [],
            }
        },
        methods: {
            clickCallback: function (pageNum) {
                axios.get('api/book?page=' + pageNum).then(({ data }) => (this.books = data.data));

            },
          getResults(page = 1) {
              this.$Progress.start();

              axios.get('api/book?page=' + page).then(({ data }) => (this.books = data.data));

              this.$Progress.finish();
          },
          loadBooks(){

            // if(this.$gate.isAdmin()){
              axios.get("api/book").then(({ data }) => (this.books = data.data));
            // }
          },
          loadStatus(){
              axios.get("/api/status/list").then(({ data }) => (this.status = data.data));
          },
          editModal(book){
              this.editmode = true;
              this.form.reset();
              $('#addNew').modal('show');
              this.form.fill(book);
          },
          newModal(){
              this.editmode = false;
              this.form.reset();
              $('#addNew').modal('show');
          },
          createBook(){
              this.$Progress.start();

              this.form.post('api/book')
              .then((data)=>{
                if(data.data.success){
                  $('#addNew').modal('hide');

                  Toast.fire({
                        icon: 'success',
                        title: data.data.message
                    });
                  this.$Progress.finish();
                  this.loadBooks();

                } else {
                  Toast.fire({
                      icon: 'error',
                      title: 'Some error occured! Please try again'
                  });

                  this.$Progress.failed();
                }
              })
              .catch(()=>{

                  Toast.fire({
                      icon: 'error',
                      title: 'Some error occured! Please try again'
                  });
              })
          },
          updateBook(){
              this.$Progress.start();
              this.form.put('api/book/'+this.form.id)
              .then((response) => {
                  // success
                  $('#addNew').modal('hide');
                  Toast.fire({
                    icon: 'success',
                    title: response.data.message
                  });
                  this.$Progress.finish();
                      //  Fire.$emit('AfterCreate');

                  this.loadBooks();
              })
              .catch(() => {
                  console.log(2)
                  this.$Progress.fail();
              });

          },
          deleteBook(id){
              Swal.fire({
                  title: 'Are you sure?',
                  text: "You won't be able to revert this!",
                  showCancelButton: true,
                  confirmButtonColor: '#d33',
                  cancelButtonColor: '#3085d6',
                  confirmButtonText: 'Yes, delete it!'
                  }).then((result) => {

                      // Send request to the server
                        if (result.value) {
                              this.form.delete('api/book/'+id).then(()=>{
                                      Swal.fire(
                                      'Deleted!',
                                      'Your file has been deleted.',
                                      'success'
                                      );
                                  // Fire.$emit('AfterCreate');
                                  this.loadBooks();
                              }).catch((data)=> {
                                  Swal.fire("Failed!", data.message, "warning");
                              });
                        }
                  })
          },

        },
        mounted() {
            this.$Progress.finish();
        },
        created() {
            this.$Progress.start();

            this.loadBooks();
            this.loadStatus();

            this.$Progress.finish();
        },
        filters: {
            truncate: function (text, length, suffix) {
                return text.substring(0, length) + suffix;
            },
        },
        computed: {
          filteredItems() {
            return this.autocompleteItems.filter(i => {
              return i.text.toLowerCase().indexOf(this.tag.toLowerCase()) !== -1;
            });
          },
        },
    }
</script>
